mtl-2.1.2: Monad classes, using functional dependencies

Portability | non-portable (multi-param classes, functional dependencies)
Stability | experimental
Maintainer | libraries@haskell.org
Safe Haskell | Safe-Inferred

Control.Monad.RWS.Lazy

Contents

- The RWS monad
- The RWST monad transformer
- Lazy Reader-writer-state monads

Description

Lazy RWS monad.

Inspired by the paper Functional Programming with Overloading and Higher-Order Polymorphism, Mark P Jones (http://web.cecs.pdx.edu/~mpj/) Advanced School of Functional Programming, 1995.

Synopsis

- type RWS r w s = RWST r w s Identity
- rws :: (r -> s -> (a, s, w)) -> RWS r w s a
- runRWS :: RWS r w s a -> r -> s -> (a, s, w)
- evalRWS :: RWS r w s a -> r -> s -> (a, w)
- execRWS :: RWS r w s a -> r -> s -> (s, w)
- mapRWS :: ((a, s, w) -> (b, s, w')) -> RWS r w s a -> RWS r w' s b
- withRWS :: (r' -> s -> (r, s)) -> RWS r w s a -> RWS r' w s a
- newtype RWST r w s m a = RWST {
  - runRWST :: r -> s -> m (a, s, w)
  }
- evalRWST :: Monad m => RWST r w s m a -> r -> s -> m (a, w)
- execRWST :: Monad m => RWST r w s m a -> r -> s -> m (s, w)
- mapRWST :: (m (a, s, w) -> n (b, s, w')) -> RWST r w s m a -> RWST r w' s n b
- withRWST :: (r' -> s -> (r, s)) -> RWST r w s m a -> RWST r' w s m a
- module Control.Monad.RWS.Class
- module Control.Monad
- module Control.Monad.Fix
- module Control.Monad.Trans
- module Data.Monoid

# The RWS monad

type RWS r w s = RWST r w s Identity

A monad containing an environment of type `r`, output of type `w` and an updatable state of type `s`.

rws :: (r -> s -> (a, s, w)) -> RWS r w s a

Construct an RWS computation from a function. (The inverse of `runRWS`.)

runRWS :: RWS r w s a -> r -> s -> (a, s, w)

Unwrap an RWS computation as a function. (The inverse of `rws`.)

evalRWS

Arguments

:: RWS r w s a | RWS computation to execute
-> r | initial environment
-> s | initial value
-> (a, w) | final value and output

Evaluate a computation with the given initial state and environment, returning the final value and output, discarding the final state.

execRWS

Arguments

:: RWS r w s a | RWS computation to execute
-> r | initial environment
-> s | initial value
-> (s, w) | final state and output

Evaluate a computation with the given initial state and environment, returning the final state and output, discarding the final value.

mapRWS :: ((a, s, w) -> (b, s, w')) -> RWS r w s a -> RWS r w' s b

Map the return value, final state and output of a computation using the given function.

-     runRWS (mapRWS f m) r s = f (runRWS m r s)

withRWS :: (r' -> s -> (r, s)) -> RWS r w s a -> RWS r' w s a

``withRWS` f m` executes action `m` with an initial environment and state modified by applying `f`.

-     runRWS (withRWS f m) r s = uncurry (runRWS m) (f r s)

# The RWST monad transformer

newtype RWST r w s m a

A monad transformer adding reading an environment of type `r`, collecting an output of type `w` and updating a state of type `s` to an inner monad `m`.

Constructors

RWST |
Fields runRWST :: r -> s -> m (a, s, w)

Instances

(Monoid w, Monad m) => MonadRWS r w s (RWST r w s m) |
(Monoid w, Monad m) => MonadWriter w (RWST r w s m) |
(Monad m, Monoid w) => MonadState s (RWST r w s m) |
(Monad m, Monoid w) => MonadReader r (RWST r w s m) |
(Monoid w, MonadError e m) => MonadError e (RWST r w s m) |
Monoid w => MonadTrans (RWST r w s) |
(Monoid w, Monad m) => Monad (RWST r w s m) |
Functor m => Functor (RWST r w s m) |
(Monoid w, MonadFix m) => MonadFix (RWST r w s m) |
(Monoid w, MonadPlus m) => MonadPlus (RWST r w s m) |
(Monoid w, Functor m, Monad m) => Applicative (RWST r w s m) |
(Monoid w, Functor m, MonadPlus m) => Alternative (RWST r w s m) |
(Monoid w, MonadIO m) => MonadIO (RWST r w s m) |
(Monoid w, MonadCont m) => MonadCont (RWST r w s m) |

evalRWST

Arguments

:: Monad m |
=> RWST r w s m a | computation to execute
-> r | initial environment
-> s | initial value
-> m (a, w) | computation yielding final value and output

Evaluate a computation with the given initial state and environment, returning the final value and output, discarding the final state.

execRWST

Arguments

:: Monad m |
=> RWST r w s m a | computation to execute
-> r | initial environment
-> s | initial value
-> m (s, w) | computation yielding final state and output

Evaluate a computation with the given initial state and environment, returning the final state and output, discarding the final value.

mapRWST :: (m (a, s, w) -> n (b, s, w')) -> RWST r w s m a -> RWST r w' s n b

Map the inner computation using the given function.

-     runRWST (mapRWST f m) r s = f (runRWST m r s)

withRWST :: (r' -> s -> (r, s)) -> RWST r w s m a -> RWST r' w s m a

``withRWST` f m` executes action `m` with an initial environment and state modified by applying `f`.

-     runRWST (withRWST f m) r s = uncurry (runRWST m) (f r s)

# Lazy Reader-writer-state monads

module Control.Monad.RWS.Class

module Control.Monad

module Control.Monad.Fix

module Control.Monad.Trans

module Data.Monoid